		.386p
		jumps

code32		segment para public use32
		assume cs:code32, ds:code32

		include ..\extern\pmode.inc
		include ..\extern\sinustab.inc
		include xmode3.inc

routine_timers = 1



		public _main

_main:	sti	
	call	init_toetsenbord

	mov	[scherm_resolutie],m376x282
	mov	[scherm_modulo],0
	call	zet_xmode
	jc	eruit

	lea	eax,object1
	mov	[object_ptr],eax
	lea	eax,object_vlak1
	mov	[objectvlak_ptr],eax

routines:
	call	wissel_schermen
	routine_speed 1
	call	scherm_schoon
	routine_speed 2
	add	[x_hoek],3
	and	[x_hoek],1024-1
	add	[y_hoek],5
	and	[y_hoek],1024-1
	add	[z_hoek],4
	and	[z_hoek],1024-1
	routine_speed 3
	call	roteer_matrix
	routine_speed 4
	call	model_3d
	routine_speed 0
escape:
        in 	al,60h			; escape ingedrukt?
        cmp 	al,1
        jne 	routines
escape_los:
        in 	al,60h			; escape los?
        cmp 	al,1
        je 	short escape_los

eruit:	call	zet_tmode
	call	reset_toetsenbord
	jmp 	_exit

vlak_aantal	dw 0
vlak_teller	dw 0
model_3d:
	lea	esi,hoekpunten_2d	;resultaat coords
	mov	edi,[objectvlak_ptr]

	mov	ax,[edi+0]		;aantal vlakken
	mov	[vlak_aantal],ax
	mov	[vlak_teller],0
	add	edi,2
draad_lp:
;	jmp	short wel_tezien	; positief dan tekenen
	mov	bp,[edi+4]		; kruis vector product
	and	ebp,0ffffh
	movsx	eax,word ptr [esi+ebp*4]
	movsx	ebx,word ptr [esi+2+ebp*4]
	mov	bp,[edi+6]
	movsx	ecx,word ptr [esi+ebp*4]
	movsx	edx,word ptr [esi+2+ebp*4]
	mov	bp,[edi+8]
	movsx	ebp,word ptr [esi+ebp*4]
	sub	eax,ebp
	sub	ecx,ebp
	and	ebp,0ffffh
	mov	bp,[edi+8]
	movsx	ebp,word ptr [esi+2+ebp*4]
	sub	ebx,ebp
	sub	edx,ebp
	imul	edx,eax
	imul	ecx,ebx
	sub	edx,ecx
	jg	short wel_tezien	; positief dan tekenen

	mov	cx,[edi+0]		; aantal hoekpunten
	and	ecx,0ffffh		
	shl	ecx,1	
	add	edi,ecx			; trek er een vlak vanaf
	add	edi,6
	dec	[vlak_aantal]
	jnz	draad_lp	
	ret

wel_tezien:
	mov	cx,[edi+0]		; aantal hoekpunten
	mov	ax,[edi+2]		; kleur
	mov	[kleur],al
	mov	[laagste_y],281
	mov	[hoogste_y],0
	add	edi,4
vl_loop:
	push	cx
	mov	bp,[edi+0]
	and	ebp,0ffffh
	mov	ax,[esi+ebp*4]		; x1
	mov	bx,[esi+2+ebp*4]	; y1
	mov	bp,[edi+2]
	mov	cx,[esi+ebp*4]		; x2
	mov	dx,[esi+2+ebp*4]	; y2

	mov	[welke_x],0
	cmp	dx,bx
	je	short niet_naar_buffer
	jl	short naar_benee
	mov	[welke_x],2
naar_benee:

	push	edi esi
	call	vul_lijn
buiten_beeld:
	pop	esi edi

niet_naar_buffer:
	add	edi,2
	pop	cx
	dec	cx
	jnz	vl_loop

	push	edi esi
	call	vulvlak
	pop	esi edi

volgende_vlak:
	add	edi,2		;spring naar volgende vlakdata
	dec	[vlak_aantal]
	jnz	draad_lp	
	ret



vulvlak:
	mov	bx,[laagste_y]
	mov	cx,[hoogste_y]
	and	eax,0ffffh
	and	ebx,0ffffh
	and	ecx,0ffffh
	lea	esi,[vullijn_tabel+ebx*4]
	sub	cx,bx
	js	stop_vul
	inc	[vlak_teller]
vulloop:
	push	ecx
	mov	ax,[esi+0]	
	mov	cx,[esi+2]	

;	cmp	cx,ax			; van links naar rechts vullen !
;	jg	short naar_rechts
;	xchg	cx,ax
naar_rechts:
	cmp	ax,0
	jge	cll_ok
	mov	ax,0
cll_ok:
	cmp	cx,375
	jle	clr_ok
	mov	cx,375
clr_ok:
	push	ebx
	call	lijn_vuller
	pop	ebx
nietvl:
	inc	bx
	add	esi,4
	pop	ecx
	dec	cx
	jnz	short vulloop
stop_vul:
	ret

laagste_y	dw	281
hoogste_y	dw	0
welke_x		dd	0

	align 4

vul_lijn:
	cmp	dx,bx
	je	stop_vlijn
	jg	short naar_beneden
	xchg	cx,ax
	xchg	dx,bx
naar_beneden:
	lea	edi,[vullijn_tabel]
	add	edi,[welke_x]
	cmp	[laagste_y],bx
	jle	short niet_laagste
	mov	[laagste_y],bx
niet_laagste:
	cmp	[hoogste_y],dx
	jge	short niet_hoogste
	mov	[hoogste_y],dx
niet_hoogste:
	sub	cx,ax	;delta x
	sub	dx,bx	;delta y

	mov	bp,dx
	and	ebp,0ffffh

	rol	ecx,16
	xor	cx,cx

	push	eax
	mov	eax,ecx
	xor	edx,edx
	cdq
	idiv	ebp
	mov	ecx,eax
	pop	eax 

	and	eax,0ffffh
	and	ebx,0ffffh

maak_vlijn:
	mov	[edi+ebx*4],ax
	ror	eax,16
	add	eax,ecx
	rol	eax,16
	inc	ebx
	dec	bp
	jnz	short maak_vlijn
stop_vlijn:
	ret

ystart	dd 0
ylengte dw 0

kleur		db 0
vul_mask	db	1,3,7,15
lijn_vuller:
	and	eax,0ffffh		; x0
	and	ebx,0ffffh		;y lijnvuller
	and	ecx,0ffffh		; x1
	mov	edi,[werk_scherm]
	add	edi,[mul_tabel+ebx*4]
	mov	bx,cx
	sub	bx,ax			; aantal horizontale pixels

	mov	cx,ax
	and	cx,3
	shr	eax,2
	add	edi,eax
	mov	dx,3c4h
	mov	ax,0f02h

	cmp	bx,4
	jl	kleiner_dan4
	or	cx,cx
	jz	short snel_vul

	shl	ah,cl
	out	dx,ax
	mov	al,[kleur]
	mov	[edi],al
	inc	edi	
	mov	ax,0f02h

	xor	cx,3
	sub	bx,cx
	dec	bx
	js	stoplijnvul
	cmp	bx,4
	jl	short rest_pix
snel_vul:	
	out	dx,ax
	mov	cl,[kleur]
	mov	ch,cl
	cmp	bx,16
	jl	short zet_8pix
	mov	bp,cx
	shl	ecx,16
	mov	cx,bp
	mov	bp,bx
	shr	bp,4
	shl	bp,4
	sub	bx,bp
	shr	bp,4
zet_16pix:
	mov	[edi],ecx
	add	edi,4
	dec	bp
	jnz	short zet_16pix	
	or	bx,bx
	js	short stoplijnvul
zet_8pix:	
	cmp	bx,8
	jl	short zet_4pix
	mov	[edi],cx
	add	edi,2
	sub	bx,8
	js	short stoplijnvul
zet_4pix:
	cmp	bx,4
	jl	short rest_pix
	mov	[edi],cl
	inc	edi
	sub	bx,4
	js	short stoplijnvul
	jmp	short rest_pix
kleiner_dan4:
	or	bl,bl
	jz	short stoplijnvul
	mov	ah,vul_mask[ebx]
	shl	ah,cl
	out	dx,ax
	mov	al,[kleur]
	mov	[edi],al
	mov	al,2
	add	bl,cl
	sub	bl,4
	js	short stoplijnvul
	inc	edi
rest_pix:
	mov	ah,vul_mask[ebx]
	out	dx,ax
	mov	al,[kleur]
	mov	[edi],al
stoplijnvul:
	ret


x_hoek		dw 0
y_hoek		dw 0
z_hoek		dw 0
x_sin 		dd 0
x_cos 		dd 0
y_sin 		dd 0
y_cos 		dd 0
z_sin 		dd 0
z_cos 		dd 0
x_centrum	dd 0
y_centrum	dd 0
z_centrum	dd 11000
object_ptr	dd 0
objectvlak_ptr	dd 0

z_afstand	= 9	

aantal_coords	dw 0
hoekpunten_2d: 	dw 1000 dup (0,0)
vullijn_tabel	dw 282 dup (0,0)

object1:	dw	8
		dw	-100,-100,100
		dw	-100,100,100
		dw	100,100,100
		dw	100,-100,100
		dw	-100,-100,-100
		dw	-100,100,-100
		dw	100,100,-100
		dw	100,-100,-100

object_vlak1:	dw	6
		dw	4,8,0,1,2,3,0
		dw	4,9,4,7,6,5,4
		dw	4,10,0,4,5,1,0
		dw	4,11,3,2,6,7,3
		dw	4,12,1,5,6,2,1
		dw	4,13,0,3,7,4,0


roteer_matrix:
	lea	ecx,sinustabel
	lea	edx,cosinustabel
	mov	esi,[object_ptr]	;bron coords
	lea	edi,hoekpunten_2d	;resultaat coords

	movzx	eax,[x_hoek]		;sinus & cosinus halen voor hoek x
	movsx	ebx,word ptr [ecx+eax*2]
	mov	[x_sin],ebx
	movsx	ebx,word ptr [edx+eax*2]
	mov	[x_cos],ebx

	movzx	eax,[y_hoek]		;sinus & cosinus halen voor hoek y
	movsx	ebx,word ptr [ecx+eax*2]
	mov	[y_sin],ebx
	movsx	ebx,word ptr [edx+eax*2]
	mov	[y_cos],ebx

	movzx	eax,[z_hoek]		;sinus & cosinus halen voor hoek z
	movsx	ebx,word ptr [ecx+eax*2]
	mov	[z_sin],ebx
	movsx	ebx,word ptr [edx+eax*2]
	mov	[z_cos],ebx

	mov	cx,[esi+0]
	mov	[aantal_coords],cx
	add	esi,2
roteer_coords:
	push	cx edi

	movsx	eax,word ptr [esi+0]
	movsx	ebx,word ptr [esi+2]
	movsx	ecx,word ptr [esi+4]

	sal	ax,4	
	sal	bx,4	
	sal	cx,4	

	mov	ebp,[z_cos]	;cosinus
	mov	edi,[z_sin]	;sinus
	mov	edx,edi		;sinus copieren naar edx
	add	edi,ebp		;sinus+cosinus
	imul	edx,ebx
	imul	ebp,eax
	add	ebx,eax
	mov	eax,ebp
	sub	eax,edx
	sar	eax,16		;op de amiga heb je swap !!
	add	ax,ax	
	add	ax,ax	
	imul	ebx,edi
	sub	ebx,edx
	sub	ebx,ebp
	sar	ebx,16
	add	bx,bx
	add	bx,bx

	mov	ebp,[x_cos]	;cosinus
	mov	edi,[x_sin]	;sinus
	mov	edx,edi		;sinus copieren naar edx
	add	edi,ebp		;sinus+cosinus
	imul	edx,ebx
	imul	ebp,ecx
	add	ebx,ecx
	mov	ecx,ebp
	sub	ecx,edx
	sar	ecx,16		;op de amiga heb je swap !!
	add	cx,cx	
	add	cx,cx	
	imul	ebx,edi
	sub	ebx,edx
	sub	ebx,ebp
	sar	ebx,16
	add	bx,bx
	add	bx,bx

	mov	ebp,[y_cos]	;cosinus
	mov	edi,[y_sin]	;sinus
	mov	edx,edi		;sinus copieren naar edx
	add	edi,ebp		;sinus+cosinus
	imul	edx,eax
	imul	ebp,ecx
	add	eax,ecx
	mov	ecx,ebp
	sub	ecx,edx
	sar	ecx,16		;op de amiga heb je swap !!
	add	cx,cx	
	add	cx,cx	
	imul	eax,edi
	sub	eax,edx
	sub	eax,ebp
	sar	eax,16
	add	ax,ax
	add	ax,ax

	pop	edi

	add	eax,[x_centrum]
	add	ebx,[y_centrum]
	add	ecx,[z_centrum]
	jnz	short deling_ok
	inc	ecx
deling_ok:
	sal	eax,z_afstand
	xor	edx,edx
	cdq
	idiv	ecx
	add	ax,376/2
	mov	[edi+0],ax
	mov	eax,ebx
	sal	eax,z_afstand
	xor	edx,edx
	cdq
	idiv	ecx
	add	ax,282/2
	mov	[edi+2],ax

	add	edi,4
	add	esi,6
	pop	cx
	dec	cx
	jnz	roteer_coords	
	ret

code32	ends
	end
